# For transformation from env variables to neater configuration descriptions

XFORM_LUT = {
    '0_st-0': 'R',
    '1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22_st-0': 'X',
    '1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22_st-1': 'Xs'
}

MTCONF_LUT = {
    '0': '1c1t0s',
    '0,1': '1c2t0s',
    '0,8' : '2c2t0s',
    '0,16': '1c2t1s',
    '0,1,2,3': '1c4t0s',
    '0,1,8,9' : '2c4t0s',
    '0,1,16,17': '1c4t2s',
    '0,1,2,3,4,5,6,7': '1c8t0s',
    '0,1,2,3,8,9,10,11' : '2c8t0s',
    '0,1,2,3,16,17,18,19': '1c8t4s',
    '0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15' : '2c16t0s',
    '0,1,2,3,4,5,6,7,16,17,18,19,20,21,22,23': '1c16t8s',
    '0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31' : '2c32t16s'
}

# For sorting of configurations in graphs

CONF_SORT_LUT = [
    '1c1t0sR', '1c1t0sX', '1c1t0sXs',
    '1c2t0sR', '1c2t0sX', '1c2t0sXs',
    '2c2t0sR', '2c2t0sX', '2c2t0sXs',
    '1c2t1sR', '1c2t1sX', '1c2t1sXs',
    '1c4t0sR', '1c4t0sX', '1c4t0sXs',
    '2c4t0sR', '2c4t0sX', '2c4t0sXs',
    '1c4t2sR', '1c4t2sX', '1c4t2sXs',
    '1c8t0sR', '1c8t0sX', '1c8t0sXs',
    '2c8t0sR', '2c8t0sX', '2c8t0sXs',
    '1c8t4sR', '1c8t4sX', '1c8t4sXs',
    '2c16t0sR', '2c16t0sX', '2c16t0sXs',
    '1c16t8sR', '1c16t8sX', '1c16t8sXs',
    '2c32t16sR', '2c32t16sX', '2c32t16sXs'
]

CONF_CSR_SORT_LUT = [
    '1c1t0sR',
    '1c2t0sR',
    '2c2t0sR',
    '1c2t1sR',
    '1c4t0sR',
    '2c4t0sR',
    '1c4t2sR',
    '1c8t0sR',
    '2c8t0sR',
    '1c8t4sR',
    '2c16t0sR',
    '1c16t8sR',
    '2c32t16sR'
]

CONF_CSR_MIN_SORT_LUT = [
    '1c1t0sR',
    '1c2t0sR',
    '1c4t0sR',
    '1c8t0sR',
    '1c16t8sR',
]

CONF_CSX_SORT_LUT = [
    '1c1t0sX',
    '1c2t0sX',
    '2c2t0sX',
    '1c2t1sX',
    '1c4t0sX',
    '2c4t0sX',
    '1c4t2sX',
    '1c8t0sX',
    '2c8t0sX',
    '1c8t4sX',
    '2c16t0sX',
    '1c16t8sX',
    '2c32t16sX'
]

CONF_CSX_MIN_SORT_LUT = [
    '1c1t0sX',
    '1c2t0sX',
    '1c4t0sX',
    '1c8t0sX',
    '1c16t8sX',
]

CONF_CSXS_SORT_LUT = [
    '1c1t0sXs',
    '1c2t0sXs',
    '2c2t0sXs',
    '1c2t1sXs',
    '1c4t0sXs',
    '2c4t0sXs',
    '1c4t2sXs',
    '1c8t0sXs',
    '2c8t0sXs',
    '1c8t4sXs',
    '2c16t0sXs',
    '1c16t8sXs',
    '2c32t16sXs'
]

# Confs used for EDR plots
CONF_SPEEDUP_MIN_SORT_LUT = [
    '1c1t0s',
    '1c2t0s',
    '1c4t0s',
    '1c8t0s',
    '1c16t8s',
]

# Confs used by socket plots
CONF_SOCKET_SORT_LUT = [
    '1c2t0sR', '1c2t0sX', '1c2t0sXs',
    '2c2t0sR', '2c2t0sX', '2c2t0sXs',
    '1c4t0sR', '1c4t0sX', '1c4t0sXs',
    '2c4t0sR', '2c4t0sX', '2c4t0sXs',
    '1c8t0sR', '1c8t0sX', '1c8t0sXs',
    '2c8t0sR', '2c8t0sX', '2c8t0sXs',
]

CONF_SOCKET_CSR_SORT_LUT = [
    '1c2t0sR', '2c2t0sR',
    '1c4t0sR', '2c4t0sR',
    '1c8t0sR', '2c8t0sR'
]

CONF_SOCKET_CSX_SORT_LUT = [
    '1c2t0sX', '2c2t0sX',
    '1c4t0sX', '2c4t0sX',
    '1c8t0sX', '2c8t0sX'
]

# Confs used by parallel plots
CONF_PARA_CSR_SORT_LUT = [
    '1c1t0sR',
    '1c2t0sR',
    '1c4t0sR',
    '1c8t0sR',
    '2c16t0sR',
    '1c16t8sR',
    '2c32t16sR'
]
   
CONF_PARA_CSX_SORT_LUT = [
    '1c1t0sX',
    '1c2t0sX',
    '1c4t0sX',
    '1c8t0sX',
    '2c16t0sX',
    '1c16t8sX',
    '2c32t16sX'
]

CONF_PARA_COMP_SORT_LUT = [
    '1c1t0s',
    '1c2t0s',
    '1c4t0s',
    '1c8t0s',
    '2c16t0s',
    '1c16t8s',
    '2c32t16s'
]

# Confs used by smt plots

CONF_SMT_SORT_LUT = [
    '1c2t0sR', '1c2t0sX', '1c2t0sXs',
    '1c2t1sR', '1c2t1sX', '1c2t1sXs',
    '1c4t0sR', '1c4t0sX', '1c4t0sXs',
    '1c4t2sR', '1c4t2sX', '1c4t2sXs',
    '1c8t0sR', '1c8t0sX', '1c8t0sXs',
    '1c8t4sR', '1c8t4sX', '1c8t4sXs',
    '2c16t0sR', '2c16t0sX', '2c16t0sXs',
    '1c16t8sR', '1c16t8sX', '1c16t8sXs',
]



# Matrix data that might be needed

MATRIX_DATA = {
    '2cubes_sphere':    { 'rank': 101492, 'nnz': 874378,  'condition': 2.9388e+09},
    'af_5_k101':        { 'rank': 503625, 'nnz': 9027150, 'condition': 6.4275e+08},
    'af_shell3':        { 'rank': 504855, 'nnz': 9046865, 'condition': 1.4403e+06},
    'bone010':          { 'rank': 986703, 'nnz': 36326514,'condition': 1.2165e+09},
    'boneS01':          { 'rank': 127224, 'nnz': 3421188, 'condition': 4.2170e+07},
    'boneS10':          { 'rank': 914898, 'nnz': 28191660,'condition': 2.9528e+08},
    'gyro':             { 'rank': 17361,  'nnz': 519260,  'condition': 3.4851e+09},
    'LF10000':          { 'rank': 19998,  'nnz': 59990,   'condition': 6.4743e+18},
    'nasa2146':         { 'rank': 2146,   'nnz': 37198,   'condition': 4.1303e+03},
    'nasa2910':         { 'rank': 2910,   'nnz': 88603,   'condition': 1.7650e+07},
    'nasa4704':         { 'rank': 4704,   'nnz': 54730,   'condition': 1.6576e+08},
    'nasasrb':          { 'rank': 54870,  'nnz': 1366097, 'condition': 1.4836e+09},
    'olafu':            { 'rank': 16146,  'nnz': 515651,  'condition': 2.2532e+12},
    'offshore':         { 'rank': 259789, 'nnz': 2251231, 'condition': 2.3284e+13},
    'parabolic_fem':    { 'rank': 525825, 'nnz': 2100225, 'condition': 2.1108e+05},
    'Pres_Poisson':     { 'rank': 14822,  'nnz': 365313,  'condition': 3.1983e+06},
    'raefsky4':         { 'rank': 19779,  'nnz': 674195,  'condition': 1.5172e+14},
    'smt':              { 'rank': 25710,  'nnz': 1889447, 'condition': 6.1260e+09},
    'sts4098':          { 'rank': 4098,   'nnz': 38227,   'condition': 4.5095e+08}, 
    'thermal1':         { 'rank': 82654,  'nnz': 328556,  'condition': 4.9625e+05},
    'thermal2':         { 'rank': 1228045,'nnz': 4904179, 'condition': 7.4806e+06}
}

MATRIX_LIST = [
'2cubes_sphere',
'af_5_k101',
'af_shell3',
'bone010',
'boneS01',
'boneS10',
'gyro',
'LF10000',
'nasa2146',
'nasa2910',
'nasa4704',
'nasasrb',
'olafu',
'offshore',
'parabolic_fem',
'Pres_Poisson',
'raefsky4',
'smt',
'sts4098',
'thermal1',
'thermal2'
]

MATRIX_LIST_CSXS = [
'2cubes_sphere',
'af_5_k101',
'af_shell3',
'bone010',
'boneS01',
'boneS10',
'gyro',
'nasasrb',
'offshore',
'parabolic_fem',
'smt',
'thermal1',
'thermal2'
]
